"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@babel/core");

const isIIFE = node => {
  return _core.types.isCallExpression(node) && node.arguments.length === 0 && _core.types.isFunction(node.callee);
};

var _default = (path, node) => {
  if (_core.types.isReturnStatement(path.parentPath.node) && isIIFE(node)) {
    let body = node.callee.body;
    if (_core.types.isExpression(body)) body = _core.types.expressionStatement(_core.types.returnStatement(body));
    path.parentPath.replaceWithMultiple(body.body);
    return;
  }

  path.replaceWith(node);
};

exports.default = _default;