"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@babel/core");

var _isConstant = _interopRequireDefault(require("./isConstant"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isEqualConstant = (node, helpers) => {
  if ((0, _isConstant.default)(node)) return true;

  if (_core.types.isObjectExpression(node)) {
    for (const prop of node.properties) {
      if (prop.computed) {
        if (!(0, _isConstant.default)(prop.key)) return false;
      }

      if (!(0, _isConstant.default)(prop.value)) return false;
    }

    return true;
  }

  if (_core.types.isCallExpression(node)) {
    const type = helpers.getType(node.callee);

    if (type === "createElement") {
      for (const arg of node.arguments) {
        if (!isEqualConstant(arg)) return false;
      }

      return true;
    }
  }

  return false;
};

exports.default = isEqualConstant;