"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@babel/core");

var _isConstant = _interopRequireDefault(require("./isConstant"));

var _isEqualConstant = _interopRequireDefault(require("./isEqualConstant"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const checkChange = (scope, name, value, statement) => {
  const slot = scope.createSlot("old_" + name);
};

var _default = (scope, node, element, attribute, value, props, createStatements, updateStatements, unmountStatements) => {
  let valueIsConst = (0, _isConstant.default)(value);

  const captureAndCheckedUpdate = setter => {
    if (valueIsConst) {
      createStatements.push(setter(value));
    } else {
      const local = scope.createCapturedLocal(attribute, value);
      const old = scope.createSlot("old_" + attribute);
      const update = setter(_core.types.assignmentExpression("=", old, local));
      createStatements.push(update);
      updateStatements.push(_core.types.ifStatement(_core.types.binaryExpression("!==", old, local), update));
    }
  };

  const captureAndPropertyCheckedUpdate = (setter, getter) => {
    if (valueIsConst) {
      createStatements.push(setter(value));
    } else {
      const local = scope.createCapturedLocal(attribute, value);
      const old = getter();
      const update = setter(_core.types.assignmentExpression("=", old, local));
      createStatements.push(update);
      updateStatements.push(_core.types.ifStatement(_core.types.binaryExpression("!==", old, local), update));
    }
  };

  const captureAndChecked3WayUpdate = (construct, replace, remove) => {
    if (valueIsConst) {
      const old = scope.createSlot("old_" + attribute);
      createStatements.push(construct(value, value => _core.types.assignmentExpression("=", old, value)));
      unmountStatements.push(remove(old));
    } else {
      const local = scope.createCapturedLocal(attribute, value);
      const old = scope.createSlot("old_" + attribute);
      createStatements.push(construct(local, value => _core.types.assignmentExpression("=", old, value)));
      updateStatements.push(_core.types.ifStatement(_core.types.binaryExpression("!==", old, local), _core.types.blockStatement([replace(old, local, value => _core.types.assignmentExpression("=", old, value))])));
      unmountStatements.push(remove(old));
    }
  };

  const captureAndListenEvent = (event, createListener) => {
    captureAndChecked3WayUpdate((local, store) => _core.types.expressionStatement(_core.types.callExpression(scope.importHelper("addEventListener"), [scope.root(), node, _core.types.stringLiteral(event), store(createListener(local))])), (old, local, store) => _core.types.expressionStatement(_core.types.callExpression(scope.importHelper("replaceEventListener"), [scope.root(), node, _core.types.stringLiteral(event), old, store(createListener(local))])), old => _core.types.expressionStatement(_core.types.callExpression(scope.importHelper("removeEventListener"), [scope.root(), node, _core.types.stringLiteral(event), old])));
  };

  if (attribute === "ref") {
    const local = scope.createCapturedLocal(attribute, value);
    createStatements.push(_core.types.expressionStatement(_core.types.callExpression(local, [node])));
    return;
  }

  if (/^on[A-Z]/.test(attribute)) {
    let event = attribute.slice(2).toLowerCase();
    if (event === "doubleclick") event = "dblclick";

    if (element === "input" && event === "change") {
      const param = scope.helpers.getUniqueIdentifier("inputEvent");
      captureAndListenEvent("input", local => _core.types.arrowFunctionExpression([param], _core.types.logicalExpression("&&", _core.types.logicalExpression("||", _core.types.binaryExpression("===", _core.types.memberExpression(node, _core.types.identifier("type")), _core.types.stringLiteral("text")), _core.types.binaryExpression("===", _core.types.memberExpression(node, _core.types.identifier("type")), _core.types.stringLiteral("number"))), _core.types.callExpression(local, [param]))));
    }

    captureAndListenEvent(event, local => local);
    return;
  }

  switch (attribute) {
    case "style":
      {
        valueIsConst = valueIsConst || (0, _isEqualConstant.default)(value);
        const setStyle = scope.importHelper("setStyle");
        captureAndCheckedUpdate(local => _core.types.expressionStatement(_core.types.callExpression(setStyle, [node, local])));
        return;
      }

    case "value":
      {
        captureAndPropertyCheckedUpdate(local => _core.types.expressionStatement(_core.types.assignmentExpression("=", _core.types.memberExpression(node, _core.types.identifier(attribute)), local)), () => _core.types.memberExpression(node, _core.types.identifier(attribute)));
        return;
      }

    case "autoFocus":
      attribute = "autofocus";
      break;
  } // Fallback: Set property of node


  captureAndCheckedUpdate(local => _core.types.expressionStatement(_core.types.assignmentExpression("=", _core.types.memberExpression(node, _core.types.identifier(attribute)), local)));
};

exports.default = _default;