function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { RenderSymbol } from "../hooks";
import useEffect from "./useEffect";
import useRef from "./useRef";
import useMemo from "./useMemo";
import useState from "./useState";
import expandObject from "../expandObject";

function Component(props) {
  this.props = props;
}

Component[RenderSymbol] = function (props) {
  const instance = useMemo(() => {
    return new this(props);
  }, []);

  const _useState = useState(instance.state),
        _useState2 = _slicedToArray(_useState, 2),
        state = _useState2[0],
        setState = _useState2[1];

  const _useState3 = useState(0),
        _useState4 = _slicedToArray(_useState3, 2),
        forceRenderGen = _useState4[0],
        setForceRenderGen = _useState4[1];

  instance.__setForceRenderGen = setForceRenderGen;
  instance.__forceRenderGen = forceRenderGen;
  const prevForceRenderGen = useRef(null);
  const prevProps = useRef(null);
  const prevState = useRef(null);
  const prevRenderResult = useRef(null);
  const doUpdate = prevForceRenderGen.current !== forceRenderGen || !instance.shouldComponentUpdate || instance.shouldComponentUpdate(props, state);
  instance.props = props;
  instance.state = state;
  instance.__setState = setState;

  if (!doUpdate) {
    prevForceRenderGen.current = forceRenderGen;
    prevProps.current = props;
    prevState.current = state;
    return context => context.a;
  }

  useEffect(() => {
    if (instance.componentDidMount) instance.componentDidMount();
    return () => {
      if (instance.componentWillUnmount) instance.componentWillUnmount();
    };
  }, []);
  useEffect(() => {
    if (prevProps.current) {
      if (instance.componentDidUpdate) instance.componentDidUpdate(prevProps.current, prevState.current);
    }

    prevForceRenderGen.current = forceRenderGen;
    prevProps.current = props;
    prevState.current = state;
  }, expandObject(props).concat(expandObject(state)));
  return prevRenderResult.current = instance.render();
};

Component.prototype.setState = function (newState) {
  this.__setState(Object.assign({}, this.state, newState));
};

Component.prototype.forceUpdate = function () {
  this.__setForceRenderGen(this.__forceRenderGen + 1);
};

export { Component as default };