function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { createSlot, addCleanup } from "../hooks";
import { addEffect } from "../effects";
import compareDependencies from "../compareDependencies";
export default ((handler, dependencies) => {
  const _createSlot = createSlot(),
        _createSlot2 = _slicedToArray(_createSlot, 2),
        hooks = _createSlot2[0],
        index = _createSlot2[1];

  const token = {};

  if (!hooks[index]) {
    const entry = {
      dependencies,
      cleanup: undefined,
      token
    };
    hooks[index] = entry;
    addEffect(() => {
      if (entry.token !== token) return;
      const cleanup = handler();
      entry.cleanup = cleanup;
    });
    addCleanup(() => {
      if (entry.cleanup) {
        entry.cleanup();
        entry.cleanup = undefined;
      }
    });
  } else {
    const entry = hooks[index];
    if (compareDependencies(dependencies, entry.dependencies)) return;
    entry.dependencies = dependencies;
    entry.token = token;

    if (entry.cleanup) {
      entry.cleanup();
      entry.cleanup = undefined;
    }

    addEffect(() => {
      if (entry.token !== token) return;
      const cleanup = handler();
      entry.cleanup = cleanup;
    });
  }
});